/*
 * Academic License - for use in teaching, academic research, and meeting
 * course requirements at degree granting institutions only.  Not for
 * government, commercial, or other organizational use.
 *
 * File: HighBeamAssist.c
 *
 * Code generated for Simulink model 'HighBeamAssist'.
 *
 * Model version                  : 1.109
 * Simulink Coder version         : 23.2 (R2023b) 01-Aug-2023
 * C/C++ source code generated on : Sun Jun 30 21:10:46 2024
 *
 * Target selection: autosar.tlc
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "HighBeamAssist.h"
#include "Rte_Type.h"
#include "rtwtypes.h"

/* Model step function for TID1 */
void Runnable_MS(void)                 /* Explicit Task: Runnable_ms */
{
  HeadlampModes tmp;

  /* RootInportFunctionCallGenerator generated from: '<Root>/Runnable_ms' incorporates:
   *  SubSystem: '<Root>/Mode Selector'
   */
  /* Switch: '<S2>/Switch' incorporates:
   *  Constant: '<S2>/Constant'
   *  Inport: '<Root>/RPort_KeySW_state'
   *  Inport: '<Root>/RPort_Mode_val'
   */
  if (Rte_IRead_Runnable_MS_RPort_KeySW_state()) {
    tmp = Rte_IRead_Runnable_MS_RPort_Mode_mode();
  } else {
    tmp = off;
  }

  /* DataTransferBlock generated from: '<Root>/Mode Selector' incorporates:
   *  Switch: '<S2>/Switch'
   */
  Rte_IrvIWrite_Runnable_MS_IRV_ModeOut(tmp);

  /* End of Outputs for RootInportFunctionCallGenerator generated from: '<Root>/Runnable_ms' */
}

/* Model step function for TID2 */
void Runnable_HL(void)                 /* Explicit Task: Runnable_hl */
{
  boolean Lamps[2];

  /* RootInportFunctionCallGenerator generated from: '<Root>/Runnable_hl' incorporates:
   *  SubSystem: '<Root>/Headlamp Logic'
   */
  /* MATLAB Function: '<S1>/MATLAB Function' incorporates:
   *  DataTransferBlock generated from: '<Root>/Mode Selector'
   *  Inport: '<Root>/RPort_Distance_val'
   *  Inport: '<Root>/RPort_LightIntensity_val'
   *  Inport: '<Root>/RPort_VehicleSpeed_val'
   */
  switch (Rte_IrvIRead_Runnable_HL_IRV_ModeOut()) {
   case Highbeam:
    Lamps[0] = FALSE;
    Lamps[1] = TRUE;
    break;

   case Lowbeam:
    Lamps[0] = TRUE;
    Lamps[1] = FALSE;
    break;

   case Auto:
    if (Rte_IRead_Runnable_HL_RPort_VehicleSpeed_Speed() > 40U) {
      if ((Rte_IRead_Runnable_HL_RPort_Distance_Distance() > 10U) &&
          (Rte_IRead_Runnable_HL_RPort_LightIntensity_Intensity() < 200U)) {
        Lamps[0] = FALSE;
        Lamps[1] = TRUE;
      } else {
        Lamps[0] = TRUE;
        Lamps[1] = FALSE;
      }
    } else {
      Lamps[0] = TRUE;
      Lamps[1] = FALSE;
    }
    break;

   default:
    Lamps[0] = FALSE;
    Lamps[1] = FALSE;
    break;
  }

  /* End of MATLAB Function: '<S1>/MATLAB Function' */
  /* End of Outputs for RootInportFunctionCallGenerator generated from: '<Root>/Runnable_hl' */

  /* Outport: '<Root>/PPort_Lamps_val' */
  Rte_IWrite_Runnable_HL_PPort_Lamps_values(Lamps);
}

/* Model initialize function */
void Runnable_Init(void)
{
  /* (no initialization code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
